package com.logicbig.example;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import javax.validation.constraintvalidation.SupportedValidationTarget;
import javax.validation.constraintvalidation.ValidationTarget;
import java.util.Arrays;

@SupportedValidationTarget(ValidationTarget.PARAMETERS)
public class EvenNumbersInputValidator implements
        ConstraintValidator<EvenNumbers, Object[]> {

    @Override
    public void initialize(EvenNumbers constraintAnnotation) {
    }

    @Override
    public boolean isValid(Object[] value, ConstraintValidatorContext context) {
        if (value == null || value.length != 2 ||
                !(value[0] instanceof Integer) ||
                !(value[1] instanceof Integer)) {
            return false;
        }
        Integer int1 = (Integer) value[0];
        Integer int2 = (Integer) value[1];

        if (int1 % 2 != 0 || int2 % 2 != 0) {
            context.disableDefaultConstraintViolation();
            context.buildConstraintViolationWithTemplate("Either of the input parameters are not even " + Arrays
                    .toString(value))
                   .addConstraintViolation();

            return false;
        }
        if (int1.compareTo(int2) > 0) {
            context.disableDefaultConstraintViolation();
            context.buildConstraintViolationWithTemplate(String
                    .format("first input %s is not less than second input %s", int1, int2))
                   .addConstraintViolation();
            return false;
        }
        return true;
    }
}