package com.logicbig.example;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import javax.validation.constraintvalidation.SupportedValidationTarget;
import javax.validation.constraintvalidation.ValidationTarget;
import java.util.List;

@SupportedValidationTarget(ValidationTarget.ANNOTATED_ELEMENT)
public class EvenNumbersOutputValidator implements
        ConstraintValidator<EvenNumbers, List<Integer>> {

    @Override
    public void initialize(EvenNumbers constraintAnnotation) { }

    @Override
    public boolean isValid(List<Integer> value, ConstraintValidatorContext context) {
        if (value == null) {
            return false;
        }
        for (Integer integer : value) {
            if (integer % 2 != 0) {
                return false;
            }
        }
        return true;
    }
}